//=============================================================================
// BaseBotzWP.
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class BaseBotzWP expands InfoPoint
	abstract;

#exec TEXTURE IMPORT NAME=BWP_Base FILE=..\CompileData\BWP_Base.bmp FLAGS=2

struct Angulo
{
	var() float Altura, Horizontal;
};

var bool bWaitForTouch;

var(SimpleNav) float AddedOffset;	//A lo PODBot (pero no tanto zig-zagueo)
var(SimpleNav) bool bIsPreset;	//Activar si se colocan manualmente en nivel
var(SpecialNav) bool JumpToJump;
var(SpecialNav) bool ForceBruteJump;
var(SpecialNav) bool ForceDodgeJump;
var(SpecialNav) bool ForceBootsJump;
var(SpecialNav) bool ForceTransloc;
var(SpecialNav) JtJInfo JtJ;

event PreBeginPlay()
{
	if (!bIsPreset)
		return;

//	InitializeWp();
	bIsPreset = False;
}

function InitializeWp();

static function BaseBotzWP PickWpFor( actor PathTarget, optional bool bSafe)
{
	local float Dist, BestD;
	local BaseBotzWP BWP, Best;

	BestD = 5000;
	ForEach PathTarget.AllActors (class'BaseBotzWP', BWP)
	{
		if ( BWP.IsA('BotzPathInfo') ) Continue;
		if ( !PathTarget.FastTrace(BWP.Location) )
			continue;
		Dist = VSize( BWP.Location - PathTarget.Location );
		if (Dist < BestD)
		{
			BestD = Dist;
			Best = BWP;
		}
	}
	if ( (Best == none) && !bSafe)
		Log("Couldn't get Path for"@PathTarget$"!");
	return Best;
}

function BaseBotzWP SearchAPath(BaseBotzWP PathTarget, BaseBotzWP Origen, out float Dist, optional bool bIgnoreJunc);

static function FindJunctionsTo( actor PathTarget, out BotzJunction Juncs[2], out float jDist[2])
{
	local BaseBotzWP Nearest;
	local BotzPathInfo Shortcut;

	Nearest = PickWpFor( PathTarget);
	if ( Nearest.IsA('BotzGoal') )
	{
		Juncs[0] = BotzGoal( Nearest).TheJunc;
		jDist[0] = BotzGoal( Nearest).TheNode.PathInfo.GetDist( Nearest, Juncs[0]);
		return;
	}

	if ( Nearest.IsA('BotzJunction') )
	{
		Juncs[0] = BotzJunction( Nearest);
		Return;
	}

	if ( Nearest.IsA('BotzWp') )
	{
		Shortcut = BotzWp( Nearest).PathInfo;
		Juncs[0] = BotzWp( Nearest).Junctions[0];
		Juncs[1] = BotzWp( Nearest).Junctions[1];
/*		Juncs[0] = BotzJunction( Shortcut.Ruta[0] );
		Juncs[1] = BotzJunction( Shortcut.Ruta[ Arraycount( Shortcut.Ruta) - 1] );*/
		jDist[0] = Shortcut.GetDist( Nearest, Juncs[0]);
		jDist[1] = Shortcut.GetDist( Nearest, Juncs[1]);
		return;
	}
}

static final function int GetArrayA( actor AnArray[60] )
{
	local int i;

	For ( i=0 ; i<ArrayCount( AnArray) ; i++ )
		if ( AnArray[i] == none )
			return ++i;

}

event Touch( actor Other)
{
	local BaseBotzWP Next;
	local float TheDist;
	if (Other.IsA('DynamicBotzPlayer') && bWaitForTouch)
	{
		bWaitForTouch = False;
		Texture = Default.Texture;
		if ( BaseBotzWP(DynamicBotzPlayer(Other).MoveTarget) == Self)
			return;
		Next = SearchAPath( BaseBotzWP(DynamicBotzPlayer(Other).MoveTarget), self, TheDist);
		if ( Next == none )
		{
			Log("BOTZ WP: Not found path from"@self@"to"@Pawn(Other).MoveTarget);
			PlayerPawn(Other).ClientMessage("Path finding error, check log");
			return;
		}	
		Next.bWaitForTouch = True;
		Next.Texture = Texture'FerBotz.BWP_Base';
		PlayerPawn(Other).ClientMessage("Distancia medida a"@DynamicBotzPlayer(Other).MoveTarget@"es"@int(TheDist) );
	}
	if ( Other.IsA('BotZ') && Other.IsInState('NewNav') && (VSize(Pawn(Other).Destination - Location) < 10) )
		Botz(Other).StopMoving();
}

defaultproperties
{
}
