//=============================================================================
// BotzPather.
//
// Reformulado, este actor se utilizara para caminos aereos
// Caminos aereos no deberian permitir giros 180!!!
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class BotzPather expands Pawn;

var Botz MyBot;
var actor FlyObject;

var NavigationPoint LastNavig;
var int ReservedPaths[16];
var float LastCheck;
var bool bCanTurn180;
var bool bAvoidGround;

enum EFlyMethod
{
	FLY_None,
	FLY_Nuke,
	FLY_Jetpack,
	FLY_QFighter,
	FLY_Unused1,
	FLY_Unused2,
	FLY_Unused3,
	FLY_Unused4,
	FLY_Unused5
};
var EFlyMethod FlyMethod;

event PreBeginPlay() {}
event Destroyed() {}
singular event BaseChange() {}

function UpdateFlight( float DeltaTime)
{
	if ( FlyObject.bDeleteMe )
	{
		FlyObject = none;
		return;
	}
	
	if ( FlyMethod == FLY_Nuke )
	{
		
	}
}

function Died(pawn Killer, name damageType, vector HitLocation)
{
	Health = 0;
}

function SetRedeemer()
{
	bCanJump = True;
	bCanWalk = True;
	bCanSwim = True;
	bCanFly = True;
	bCanOpenDoors = False;
	bCanDoSpecial = True;
	bCanTurn180 = False;
	bAvoidGround = False;
}

function SetJetpack()
{
	bCanJump = True;
	bCanWalk = True;
	bCanSwim = True;
	bCanFly = True;
	bCanOpenDoors = True;
	bCanDoSpecial = True;
	bCanTurn180 = True;
	bAvoidGround = True;
}

function SetQuantumFighter()
{
	bCanJump = True;
	bCanWalk = True;
	bCanSwim = True;
	bCanFly = True;
	bCanOpenDoors = True;
	bCanDoSpecial = True;
	bCanTurn180 = False;
	bAvoidGround = True;
}

event Tick( float DeltaTime)
{
	if ( FlyObject != none )
		UpdateFlight( DeltaTime);
}

function SearchAPath( Actor Dest)
{
	if ( !bCanTurn180 && (LastNavig != none) )
		ReservePaths( LastNavig);
	MyBot.CostJumpSpots(False);
	MoveTarget = FindPathToward( Dest);
	if ( (MoveTarget != none) && (MoveTarget == LastNavig) )
		PopPaths();
	MyBot.CostJumpSpots(True);
	if ( ReservedPaths[0] != -1 )
		RestorePaths( LastNavig);
}

function ReservePaths( NavigationPoint N)
{
	local actor Start, End;
	local int Distance, ReachFlags, i, j;
	local bool bHasReserve;

	j = 16;
	For ( i=0 ; i<16 ; i++ )
	{
		if ( N.Paths[i] == -1 )
		{
			j = i;
			break;
		}
		ReservedPaths[i] = N.Paths[i];
		N.describeSpec( ReservedPaths[i], Start, End, ReachFlags, Distance);
		if ( (End != none) && ((LastNavig == End) || (VSize(Normal( LastNavig.Location - Location) - Normal( End.Location - Location)) < 0.3)) )
		{
			bHasReserve = true;
			N.Paths[i] = -1;
		}
	}
	if ( !bHasReserve )
	{
		ReservedPaths[0] = -1;
		return;
	}

	i=0;
	While (i<j)
	{
		if ( N.Paths[i] == -1 )
		{
			N.Paths[i] = N.Paths[--j];
			N.Paths[j] = -1;
			continue;
		}
		i++;
	}
}

function RestorePaths( NavigationPoint N)
{
	local int i;
	For ( i=0 ; i<16 ; i++ )
		N.Paths[i] = ReservedPaths[i];
}

function PopPaths()
{
	local int i;
	For ( i=0 ; i<15 ; i++ )
		RouteCache[i] = RouteCache[i+1];
	RouteCache[15] = none;
	MoveTarget = RouteCache[0];
}

defaultproperties
{
     bHidden=True
     bCanStrafe=True
     Visibility=0
     ReducedDamageType=All
     Physics=PHYS_Flying
     CollisionRadius=0.000000
     CollisionHeight=0.000000
     bCollideActors=False
     bCollideWorld=False
     bBlockActors=False
     bBlockPlayers=False
     bProjTarget=False
     bRotateToDesired=False
     bCanJump=True
     bCanWalk=True
     bCanSwim=True
     bCanFly=True
     bCanOpenDoors=False
     bCanDoSpecial=True
     Health=0
     ReservedPaths(0)=-1
     ReservedPaths(1)=-1
     ReservedPaths(2)=-1
     ReservedPaths(3)=-1
     ReservedPaths(4)=-1
     ReservedPaths(5)=-1
     ReservedPaths(6)=-1
     ReservedPaths(7)=-1
     ReservedPaths(8)=-1
     ReservedPaths(9)=-1
     ReservedPaths(10)=-1
     ReservedPaths(11)=-1
     ReservedPaths(12)=-1
     ReservedPaths(13)=-1
     ReservedPaths(14)=-1
     ReservedPaths(15)=-1
}
